package com.jboss.examples.ejb2;

import java.util.Hashtable;
import java.util.Properties;
import javax.naming.InitialContext;
import javax.naming.Context;
import javax.naming.NamingException;

import javax.security.auth.login.LoginContext;
import javax.security.auth.callback.CallbackHandler;
import org.jboss.security.auth.callback.SecurityAssociationHandler;
import org.jboss.security.SimplePrincipal;
import org.jboss.ejb.client.EJBClientConfiguration;
import org.jboss.ejb.client.ContextSelector;
import org.jboss.ejb.client.PropertiesBasedEJBClientConfiguration;
import org.jboss.ejb.client.EJBClientContext;
import org.jboss.ejb.client.remoting.ConfigBasedEJBClientContextSelector;


public class Client
{

    public static void main(String[] args) throws Exception
    {
			System.out.println();
			System.out.println("****************************************");
			System.out.println("******** Testing EJB Protocol **********");
			System.out.println("****************************************");
			testEJBProtocolScopedContext("localhost", "4447", "ejbuser", "redhat1!");

    }

		public static void testEJBProtocolScopedContext(String host, String port, String username, String password) throws Exception 
		{
        Properties p = new Properties();
        p.put("remote.connections", "default");
        p.put("remote.connection.default.port", "4447");  // the default remoting port, replace if necessary
        p.put("remote.connection.default.host", "localhost");  // the host, replace if necessary
        p.put("remote.connectionprovider.create.options.org.xnio.Options.SSL_ENABLED", "false"); // the server defaults to SSL_ENABLED=false

        //these 3 lines below are not necessary, if security-realm is removed from remoting-connector
        p.put("remote.connection.default.connect.options.org.xnio.Options.SASL_POLICY_NOANONYMOUS", "false");
        p.put("remote.connection.default.username", username);
        p.put("remote.connection.default.password", password);

        p.put(Context.URL_PKG_PREFIXES, "org.jboss.ejb.client.naming");
        p.put("org.jboss.ejb.client.scoped.context", true); // enable scoping here

        Context context = new InitialContext(p);
        Context ejbRootNamingContext = (Context) context.lookup("ejb:");
        try {

/*
           final StatefulHomeRemote home = (StatefulHomeRemote) ejbRootNamingContext.lookup("/ejb-client/StatefulBean!com.jboss.examples.ejb2.StatefulHomeRemote?stateful");
					 StatefulRemote remote = home.create();
*/

           final StatefulRemote remote = (StatefulRemote) ejbRootNamingContext.lookup("/ejb-client/StatefulBean!com.jboss.examples.ejb2.StatefulRemote?stateful");


           System.out.println("Response: " + remote.hello("Client"));
        } finally {
           try { 
               ejbRootNamingContext.close();
           } catch(Exception e) { }
           try { 
               context.close();
           } catch(Exception e) { }
        }
		}
}
