package com.jboss.examples.ejb2;

import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import javax.ejb.CreateException;

import org.apache.log4j.Logger;

public class StatefulBean implements SessionBean, StatefulInterface
{
	protected SessionContext context;
	protected Logger log = Logger.getLogger( this.getClass() );

	public void ejbCreate() throws CreateException 
	{
		log.info("ejbCreate();");
	}

	public void ejbRemove()
	{
		log.info("ejbRemove();");
	}

	public void ejbActivate()
	{
		log.info("ejbActivate();");
	}

	public void ejbPassivate()
	{
		log.info("ejbPassivate();");
	}

	public void setSessionContext(SessionContext context)
	{
		this.context = context;
	}

	public String hello(String name) 
	{
		log.info("ExampleBean hello("+name+")");
		return "Hello " + name;
	}

	public TransferReturnValue hello(TransferParameter name) 
	{
		log.info("ExampleBean hello( TransferParam: "+name+")");
		return new TransferReturnValue ( hello ( name.getValue() ) );
	}
}
